@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION
:: WinUpdateToggler
:: [ENG] De/Activates Windows Update and related settings on Windows 10.
:: [ESP] Des/Activa Windows Update y ajustes relacionados en Windows 10.


:: [ENG] SETTINGS :: In this section and the next you can find some settings. Read them and change them if you need it. Modify the settings only as indicated or the script could stop working or operate incorrectly.
:: [ESP] AJUSTES :: En esta sección y la siguiente se encuentran algunos ajustes. Léalos y cámbielos si lo necesita. Modifique los ajustes sólo como se indique o el script podría dejar de funcionar o hacerlo incorrectamente.

:LANGUAGE_SETTINGS
SET IGNORE_SYSTEM_LANGUAGE=N
:: [ENG] IGNORE_SYSTEM_LANGUAGE - The valid options are (without quotes):
::    "Y" - Ignores the detected system language.
::    "N" - Use the detected system language. (Default value)
:: [ESP] IGNORE_SYSTEM_LANGUAGE - Las opciones válidas son (sin comillas):
::    "Y" - Ignora el lenguaje detectado del sistema operativo.
::    "N" - Emplea el lenguaje detectado del sistema operativo. (Valor predeterminado)
SET FORCE_LANGUAGE=ENG
:: [ENG] FORCE_LANGUAGE - Changes the language used in the script, including menu options, messages and command-line parameters. The valid options are (without quotes):
::    "ENG" - English language. (Default value)
::    "ESP" - Spanish language.
::    Note: You must change to "Y" the IGNORE_SYSTEM_LANGUAGE setting in order to force the selected language; otherwise the script will always try to detect the operating system language.
:: [ESP] FORCE_LANGUAGE - Altera el lenguaje empleado en el script, incluyendo las opciones del menú, mensajes y parámetros de línea de comandos. Las opciones válidas son (sin comillas):
::    "ENG" - Lenguaje inglés. (Default value)
::    "ESP" - Lenguaje español.
::    Nota: Debe cambiar a "Y" el ajuste IGNORE_SYSTEM_LANGUAGE para poder forzar el lenguaje elegido; de otro modo el script siempre intentará detectar el lenguaje del sistema operativo.
CALL :CHECKS %*


:USER_SETTINGS
:: [ENG] USER SETTINGS - You can change these settings if you know what you are doing.
::    These default settings affect command-line, menu options and user interface.
::    The valid options for all are: !ON! and !OFF! (including exclamation marks).
::    Also the settings SCHEDULED_TASKS, WINDOWS_UPDATE, DRIVERS_UPDATE, ETHERNET_CONNECTION_METERED and UPDATES_DELIVERY_P2P can use !IGNORE! too - this will leave the setting as it was, unchanged.
::    Default values for all the user settings: CHECK_UPDATES (!OFF!), SCHEDULED_TASKS (!IGNORE!), ADVANCED_OPTIONS_DEFAULT_STATE (!OFF!), CONSOLE_WINDOW_CHANGE (!ON!), CONSOLE_WINDOW_RESTORE (!ON!), CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY (!OFF!), WINDOWS_UPDATE (!IGNORE!), DRIVERS_UPDATE (!IGNORE!), ETHERNET_CONNECTION_METERED (!IGNORE!), UPDATES_DELIVERY_P2P (!IGNORE!), DELETE_SOFTWAREDISTRIBUTION (!OFF!)
:: [ESP] AJUSTES DE USUARIO - Puede cambiar estos ajustes si sabe lo que está haciendo.
::    Estos ajustes predeterminados afectan a la línea de comandos, a las opciones del menú y a la interfaz de usuario.
::    Las opciones válidas para todos ellos son: !ON! y !OFF! (incluyendo símbolos de exclamación).
::    Además, los ajustes SCHEDULED_TASKS, WINDOWS_UPDATE, NO_AUTOREBOOT, DRIVERS_UPDATE, ETHERNET_CONNECTION_METERED y UPDATES_DELIVERY_P2P pueden emplear también !IGNORE! - esto hará que el ajuste se quede como estaba, sin ser alterado.
::    Valores predeterminados de todos los ajustes de usuario: CHECK_UPDATES (!OFF!), SCHEDULED_TASKS (!IGNORE!), ADVANCED_OPTIONS_DEFAULT_STATE (!OFF!), CONSOLE_WINDOW_CHANGE (!ON!), CONSOLE_WINDOW_RESTORE (!ON!), CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY (!OFF!), WINDOWS_UPDATE (!IGNORE!), NO_AUTOREBOOT (!IGNORE!), DRIVERS_UPDATE (!IGNORE!), ETHERNET_CONNECTION_METERED (!IGNORE!), UPDATES_DELIVERY_P2P (!IGNORE!), DELETE_SOFTWAREDISTRIBUTION (!OFF!)
SET CHECK_UPDATES=!OFF!
SET SCHEDULED_TASKS=!IGNORE!
SET ADVANCED_OPTIONS_DEFAULT_STATE=!OFF!
SET WINDOWS_UPDATE=!IGNORE!
SET NO_AUTOREBOOT=!IGNORE!
SET DRIVERS_UPDATE=!IGNORE!
SET ETHERNET_CONNECTION_METERED=!IGNORE!
SET UPDATES_DELIVERY_P2P=!IGNORE!
SET DELETE_SOFTWAREDISTRIBUTION=!IGNORE!

:: [ENG] The next two settings change how the script will modify the console window size and screen buffer.
::    CONSOLE_WINDOW_CHANGE will detect and ask if the user wants to apply the changes even if it's set as !ON!.
::    CONSOLE_WINDOW_RESTORE will allow the user to keep the optimized window size and screen buffer assigned by the script - only if the previous setting is !ON! and this one is !OFF!.
::    CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY will determine the script's reaction about the changes to the console window when command-line parameters are used. The valid options are !ON!, !OFF! and !IGNORE!. If the value of this setting is !ON! the script will apply the proposed changes -if necessary- for the console window before going through the requested Windows Update modifications. If the value of this setting is !OFF! the script will skip the console window related menu and proceed with the command-line requested modifications without further considerations about the console window. IF the value of this setting is !IGNORE! the script will ask the user normally -and stopping the script execution- regarding the changes about the console window before resuming the process.
:: [ESP] Los dos ajustes siguientes cambian el modo en que el script modificará la ventana de consola y sus reservas de pantalla.
::    CONSOLE_WINDOW_CHANGE detectará y preguntará al usuario si desea aplicar los cambios incluso si está ajustada a !ON!.
::    CONSOLE_WINDOW_RESTORE permitirá al usuario mantener los valores de dimensiones de la ventana de consola y sus reservas de pantalla asignadas por el script - sólo si el ajuste anterior está en !ON! y este en !OFF!.
::    CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY condicionará la reacción del script respecto a los cambios de la ventana de consola cuando se empleen parámetros de línea de comandos. Las opciones válidas son !ON!, !OFF! e !IGNORE!. Si su valor está en !ON! el script aplicará automáticamente los cambios a la ventana de consola -si es que son necesarios- antes de realizar los cambios solicitados para Windows Update. Si su valor está en !OFF! saltará el menú relacionado con la ventana de consola y realizará los cambios solicitados mediante línea de comandos sin más consideraciones sobre la ventana de consola. Si su valor está en !IGNORE! preguntará normalmente al usuario -parando la ejecución del script- respecto a los cambios sobre la ventana de consola antes de continuar.
SET CONSOLE_WINDOW_CHANGE=!ON!
SET CONSOLE_WINDOW_RESTORE=!ON!
SET CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY=!OFF!

:: [ENG] WinUpdateToggler can use PsExec (by Mark Russinovich and currently part of Microsoft TechNet) to modify some permission protected files, services and scheduled tasks in Windows 10. This tool is not _needed_ but will be very helpful for the purpose of this script from Windows 10 v.1703 onward. You can download PsTools/PsExec from this link: https://docs.microsoft.com/en-us/sysinternals/downloads/psexec
::    Important: Place the PsExec.exe/PsExec64.exe file in the same folder as this script so it can be used. Note that, although there are many files inside the PSTools.zip archive, only the PsExec executables are useful for WinUpdateToggler.
::    There are two settings related to this functonality:
::    USE_PSEXEC - Enables (or not) the use of PsExec by this script.
::        The valid options are: !ON! (default value) and !OFF!.
::    PSEXEC_EULA - This setting can help you automate the use of PsExec on every computer that runs this script by accepting automatically the EULA (End-User License Agreement). If you enable this setting it means that you accept the EULA of PsExec — please, read its EULA before doing that: https://docs.microsoft.com/en-us/sysinternals/license-terms
::        The valid options are: !ON! and !OFF! (default value).
:: [ESP] WinUpdateToggler puede hacer uso de PsExec (de Mark Russinovich y actualmente parte de Microsoft TechNet) para modificar algunos ficheros, servicios y tareas programadas con permisos protegidos en Windows 10. Esta utilidad no es _necesaria_ pero será muy útil para el propósito de este script desde Windows 10 v.1703 en adelante. Puede descargar PsTools/PsExec desde este enlace: https://docs.microsoft.com/en-us/sysinternals/downloads/psexec
::    Importante: Sitúe el fichero PsExec.exe/PSExec64.exe en la misma carpeta que este script para que pueda ser utilizado. Tenga en cuenta que, aunque hay múltiples ficheros dentro del archivo PSTools.zip, sólo los ejecutables de PsExec serán útiles para WinUpdateToggler.
::    Hay dos ajustes relacionados con esta funcionalidad:
::    USE_PSEXEC - Habilita (o no) el uso de PsExec por parte de este script.
::        Las opciones válidas son: !ON! (valor predeterminado) y !OFF!.
::    PSEXEC_EULA - Este ajuste puede ayudarle a automatizar el uso de PsExec en todos los ordenadores que inicien este script al aceptar automáticamente el EULA, también llamado CLUF (Contrato de Licencia para el Usuario Final). Si habilita este ajuste significará que acepta el EULA de PsExec — por favor, lea su EULA antes de hacer eso: https://docs.microsoft.com/en-us/sysinternals/license-terms
::        Las opciones válidas son: !ON! y !OFF! (valor predeterminado).
SET USE_PSEXEC=!ON!
SET PSEXEC_EULA=!OFF!
:: ===================================================================================================================================================================================================
:: [ENG] IMPORTANT: Please, do NOT change anything beyond this point.
:: [ESP] IMPORTANTE: Por favor, NO cambie nada a partir de este punto.


CALL :APPLY_USER_SETTINGS %*
CALL :CHECK_COMMAND_LINE %*
CALL :MENU_SETTINGS
CALL :MENU
CALL :END 0


:CHECK_COMMAND_LINE
SET CHANGES_CMDLINE=0
IF "%~1"=="" EXIT /B

FOR %%P IN (!ALL_PARAMS!) DO (
    IF /I "%%P"=="-!CMDLINE_NA!!ON!" (SET CHANGES_CMDLINE=1) & (SET NO_AUTOREBOOT=!ON!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_NA!!OFF!" (SET CHANGES_CMDLINE=1) & (SET NO_AUTOREBOOT=!OFF!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_DU!!ON!" (SET CHANGES_CMDLINE=1) & (SET DRIVERS_UPDATE=!ON!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_DU!!OFF!" (SET CHANGES_CMDLINE=1) & (SET DRIVERS_UPDATE=!OFF!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_MC!!ON!" (SET CHANGES_CMDLINE=1) & (SET ETHERNET_CONNECTION_METERED=!ON!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_MC!!OFF!" (SET CHANGES_CMDLINE=1) & (SET ETHERNET_CONNECTION_METERED=!OFF!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_UD!!ON!" (SET CHANGES_CMDLINE=1) & (SET UPDATES_DELIVERY_P2P=!ON!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_UD!!OFF!" (SET CHANGES_CMDLINE=1) & (SET UPDATES_DELIVERY_P2P=!OFF!) & (SET ADVANCED_OPTIONS=!ON!)
    IF /I "%%P"=="-!CMDLINE_SD!!ON!" (SET CHANGES_CMDLINE=1) & (SET DELETE_SOFTWAREDISTRIBUTION=!ON!) & (SET ADVANCED_OPTIONS=!ON!)

    IF /I "%%P"=="-!CMDLINE_WU!!ON!" (SET CHANGES_CMDLINE=1) & (SET WINDOWS_UPDATE=!ON!)
    IF /I "%%P"=="-!CMDLINE_WU!!OFF!" (SET CHANGES_CMDLINE=1) & (SET WINDOWS_UPDATE=!OFF!)
    IF /I "%%P"=="-!CMDLINE_ST!!ON!" (SET CHANGES_CMDLINE=1) & (SET SCHEDULED_TASKS=!ON!)
    IF /I "%%P"=="-!CMDLINE_ST!!OFF!" (SET CHANGES_CMDLINE=1) & (SET SCHEDULED_TASKS=!OFF!)
    IF /I "%%P"=="-!CMDLINE_CU!" (SET CHANGES_CMDLINE=1) & (SET CHECK_UPDATES=!ON!)
    )
EXIT /B


:MENU_SETTINGS
IF "!WINDOWS_UPDATE!"=="!ON!" SET MENU_PADDING_1=!MENU_PADDING_WU_ON!
IF "!WINDOWS_UPDATE!"=="!OFF!" SET MENU_PADDING_1=!MENU_PADDING_WU_OFF!
IF "!WINDOWS_UPDATE!"=="!IGNORE!" SET MENU_PADDING_1=!MENU_PADDING_WU_IGNORE!
IF "!SCHEDULED_TASKS!"=="!ON!" SET MENU_PADDING_2=!MENU_PADDING_ST_ON!
IF "!SCHEDULED_TASKS!"=="!OFF!" SET MENU_PADDING_2=!MENU_PADDING_ST_OFF!
IF "!SCHEDULED_TASKS!"=="!IGNORE!" SET MENU_PADDING_2=!MENU_PADDING_ST_IGNORE!
IF "!CHECK_UPDATES!"=="!ON!" SET MENU_PADDING_3=!MENU_PADDING_CU_ON!
IF "!CHECK_UPDATES!"=="!OFF!" SET MENU_PADDING_3=!MENU_PADDING_CU_OFF!

IF "!NO_AUTOREBOOT!"=="!ON!" SET MENU_PADDING_A=!MENU_PADDING_NA_ON!
IF "!NO_AUTOREBOOT!"=="!OFF!" SET MENU_PADDING_A=!MENU_PADDING_NA_OFF!
IF "!NO_AUTOREBOOT!"=="!IGNORE!" SET MENU_PADDING_A=!MENU_PADDING_NA_IGNORE!
IF "!DRIVERS_UPDATE!"=="!ON!" SET MENU_PADDING_B=!MENU_PADDING_DU_ON!
IF "!DRIVERS_UPDATE!"=="!OFF!" SET MENU_PADDING_B=!MENU_PADDING_DU_OFF!
IF "!DRIVERS_UPDATE!"=="!IGNORE!" SET MENU_PADDING_B=!MENU_PADDING_DU_IGNORE!
IF "!ETHERNET_CONNECTION_METERED!"=="!ON!" SET MENU_PADDING_C=!MENU_PADDING_MC_ON!
IF "!ETHERNET_CONNECTION_METERED!"=="!OFF!" SET MENU_PADDING_C=!MENU_PADDING_MC_OFF!
IF "!ETHERNET_CONNECTION_METERED!"=="!IGNORE!" SET MENU_PADDING_C=!MENU_PADDING_MC_IGNORE!
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" SET MENU_PADDING_D=!MENU_PADDING_UD_ON!
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" SET MENU_PADDING_D=!MENU_PADDING_UD_OFF!
IF "!UPDATES_DELIVERY_P2P!"=="!IGNORE!" SET MENU_PADDING_D=!MENU_PADDING_UD_IGNORE!
IF "!DELETE_SOFTWAREDISTRIBUTION!"=="!ON!" SET MENU_PADDING_E=!MENU_PADDING_SD_ON!
IF "!DELETE_SOFTWAREDISTRIBUTION!"=="!IGNORE!" SET MENU_PADDING_E=!MENU_PADDING_SD_IGNORE!

IF !CHANGES_CMDLINE!==1 (
    IF "!ADVANCED_OPTIONS!"=="!ON!" (GOTO :HUB_AO) ELSE (GOTO :HUB)
    )
IF "!ADVANCED_OPTIONS_DEFAULT_STATE!"=="!ON!" (SET ADVANCED_OPTIONS=!ON!) & (SET MENU_0=!MENU_0_ON!) ELSE (SET ADVANCED_OPTIONS=!OFF!) & (SET MENU_0=!MENU_0_OFF!)
EXIT /B


:MENU_MARK_DEFAULTS
IF "!WINDOWS_UPDATE!"=="!ON!" SET WINDOWS_UPDATE_MARK=[*]
IF "!WINDOWS_UPDATE!"=="!OFF!" SET WINDOWS_UPDATE_MARK=
IF "!SCHEDULED_TASKS!"=="!ON!" SET SCHEDULED_TASKS_MARK=[*]
IF "!SCHEDULED_TASKS!"=="!OFF!" SET SCHEDULED_TASKS_MARK=
IF "!CHECK_UPDATES!"=="!OFF!" SET CHECK_UPDATES_MARK=
IF "!CHECK_UPDATES!"=="!ON!" (
    IF "!WINDOWS_UPDATE!"=="!ON!" SET CHECK_UPDATES_MARK=
    IF "!WINDOWS_UPDATE!"=="!OFF!" SET CHECK_UPDATES_MARK=[?!]
    )
IF "!NO_AUTOREBOOT!"=="!ON!" SET NO_AUTOREBOOT_MARK=[*]
IF "!NO_AUTOREBOOT!"=="!OFF!" SET NO_AUTOREBOOT_MARK=
IF "!DRIVERS_UPDATE!"=="!ON!" SET DRIVERS_UPDATE_MARK=[*]
IF "!DRIVERS_UPDATE!"=="!OFF!" SET DRIVERS_UPDATE_MARK=
IF "!ETHERNET_CONNECTION_METERED!"=="!IGNORE!" SET ETHERNET_CONNECTION_METERED_MARK=
IF "!ETHERNET_CONNECTION_METERED!"=="!OFF!" SET ETHERNET_CONNECTION_METERED_MARK=[*]
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" SET UPDATES_DELIVERY_P2P_MARK=[*]
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" SET UPDATES_DELIVERY_P2P_MARK=
EXIT /B


:MENU
CALL :MENU_MARK_DEFAULTS
CLS
ECHO !SEPARATOR_2!
ECHO  !SCRIPT_NAME! v!VERSION!!POWERSHELL_ID!!PSEXEC_ID!
ECHO !SEPARATOR_2!
ECHO.
ECHO !TAB! !MENU_TITLE_1!
ECHO !TAB! 1. !MENU_1! !MENU_PADDING_1! [ !WINDOWS_UPDATE! ] !WINDOWS_UPDATE_MARK!
ECHO !TAB! 2. !MENU_2! !MENU_PADDING_2! [ !SCHEDULED_TASKS! ] !SCHEDULED_TASKS_MARK!
ECHO !TAB! 3. !MENU_3! !MENU_PADDING_3! [ !CHECK_UPDATES! ] !CHECK_UPDATES_MARK!
ECHO !TAB! 4. !MENU_APPLY_CO!
ECHO !TAB! 5. !MENU_EXIT!
ECHO.
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! !SEPARATOR_3!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! !MENU_TITLE_2!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_1!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_2!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_3!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_4!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_5!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! - !MENU_AO_INFO_6!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! !SEPARATOR_3!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! A. !MENU_A! !MENU_PADDING_A! [ !NO_AUTOREBOOT! ] !NO_AUTOREBOOT_MARK!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! B. !MENU_B! !MENU_PADDING_B! [ !DRIVERS_UPDATE! ] !DRIVERS_UPDATE_MARK!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! C. !MENU_C! !MENU_PADDING_C! [ !ETHERNET_CONNECTION_METERED! ] !ETHERNET_CONNECTION_METERED_MARK!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! D. !MENU_D! !MENU_PADDING_D! [ !UPDATES_DELIVERY_P2P! ] !UPDATES_DELIVERY_P2P_MARK!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! E. !MENU_E! !MENU_PADDING_E! [ !DELETE_SOFTWAREDISTRIBUTION! ]
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !TAB! 9. !MENU_APPLY_AO!
ECHO !TAB! 0. !MENU_0!
ECHO.
ECHO !MENU_INFO_1!
IF "!ADVANCED_OPTIONS!"=="!ON!" ECHO !MENU_INFO_2!
ECHO !MENU_INFO_3!
SET /P SELECTION=!MENU_PROMPT!
SET SELECTION=!SELECTION:~0,1!
IF "!SELECTION!"=="1" GOTO :TOGGLE_WU
IF "!SELECTION!"=="2" GOTO :TOGGLE_ST
IF "!SELECTION!"=="3" GOTO :TOGGLE_CU
IF "!SELECTION!"=="4" GOTO :HUB
IF "!SELECTION!"=="5" EXIT /B
IF "!ADVANCED_OPTIONS!"=="!ON!" (
    IF /I "!SELECTION!"=="A" GOTO :TOGGLE_NA
    IF /I "!SELECTION!"=="B" GOTO :TOGGLE_DU
    IF /I "!SELECTION!"=="C" GOTO :TOGGLE_MC
    IF /I "!SELECTION!"=="D" GOTO :TOGGLE_UD
    IF /I "!SELECTION!"=="E" GOTO :TOGGLE_SD
    IF "!SELECTION!"=="9" GOTO :HUB_AO
    )
IF "!SELECTION!"=="0" GOTO :TOGGLE_AO
ECHO "!SELECTION!" !MENU_ERROR_INFO!
TIMEOUT 2
GOTO :MENU


:TOGGLE_WU
IF "!WINDOWS_UPDATE!"=="!IGNORE!" (
    SET WINDOWS_UPDATE=!ON!
    SET MENU_PADDING_1=!MENU_PADDING_WU_ON!
    GOTO :MENU
    )
IF "!WINDOWS_UPDATE!"=="!ON!" (
    SET WINDOWS_UPDATE=!OFF!
    SET MENU_PADDING_1=!MENU_PADDING_WU_OFF!
    GOTO :MENU
    )
IF "!WINDOWS_UPDATE!"=="!OFF!" (
    SET WINDOWS_UPDATE=!IGNORE!
    SET MENU_PADDING_1=!MENU_PADDING_WU_IGNORE!
    GOTO :MENU
    )


:TOGGLE_ST
IF "!SCHEDULED_TASKS!"=="!IGNORE!" (
    SET SCHEDULED_TASKS=!ON!
    SET MENU_PADDING_2=!MENU_PADDING_ST_ON!
    GOTO :MENU
    )
IF "!SCHEDULED_TASKS!"=="!ON!" (
    SET SCHEDULED_TASKS=!OFF!
    SET MENU_PADDING_2=!MENU_PADDING_ST_OFF!
    GOTO :MENU
    )
IF "!SCHEDULED_TASKS!"=="!OFF!" (
    SET SCHEDULED_TASKS=!IGNORE!
    SET MENU_PADDING_2=!MENU_PADDING_ST_IGNORE!
    GOTO :MENU
    )


:TOGGLE_CU
IF "!CHECK_UPDATES!"=="!ON!" (
    SET CHECK_UPDATES=!OFF!
    SET MENU_PADDING_3=!MENU_PADDING_CU_OFF!
    GOTO :MENU
    )
SET CHECK_UPDATES=!ON!
SET MENU_PADDING_3=!MENU_PADDING_CU_ON!
GOTO :MENU


:TOGGLE_NA
IF "!NO_AUTOREBOOT!"=="!IGNORE!" (
    SET NO_AUTOREBOOT=!ON!
    SET MENU_PADDING_A=!MENU_PADDING_NA_ON!
    GOTO :MENU
    )
IF "!NO_AUTOREBOOT!"=="!ON!" (
    SET NO_AUTOREBOOT=!OFF!
    SET MENU_PADDING_A=!MENU_PADDING_NA_OFF!
    GOTO :MENU
    )
IF "!NO_AUTOREBOOT!"=="!OFF!" (
    SET NO_AUTOREBOOT=!IGNORE!
    SET MENU_PADDING_A=!MENU_PADDING_NA_IGNORE!
    GOTO :MENU
    )


:TOGGLE_DU
IF "!DRIVERS_UPDATE!"=="!IGNORE!" (
    SET DRIVERS_UPDATE=!ON!
    SET MENU_PADDING_B=!MENU_PADDING_DU_ON!
    GOTO :MENU
    )
IF "!DRIVERS_UPDATE!"=="!ON!" (
    SET DRIVERS_UPDATE=!OFF!
    SET MENU_PADDING_B=!MENU_PADDING_DU_OFF!
    GOTO :MENU
    )
IF "!DRIVERS_UPDATE!"=="!OFF!" (
    SET DRIVERS_UPDATE=!IGNORE!
    SET MENU_PADDING_B=!MENU_PADDING_DU_IGNORE!
    GOTO :MENU
    )


:TOGGLE_MC
IF "!ETHERNET_CONNECTION_METERED!"=="!IGNORE!" (
    SET ETHERNET_CONNECTION_METERED=!ON!
    SET MENU_PADDING_C=!MENU_PADDING_MC_ON!
    GOTO :MENU
    )
IF "!ETHERNET_CONNECTION_METERED!"=="!ON!" (
    SET ETHERNET_CONNECTION_METERED=!OFF!
    SET MENU_PADDING_C=!MENU_PADDING_MC_OFF!
    GOTO :MENU
    )
IF "!ETHERNET_CONNECTION_METERED!"=="!OFF!" (
    SET ETHERNET_CONNECTION_METERED=!IGNORE!
    SET MENU_PADDING_C=!MENU_PADDING_MC_IGNORE!
    GOTO :MENU
    )


:TOGGLE_UD
IF "!UPDATES_DELIVERY_P2P!"=="!IGNORE!" (
    SET UPDATES_DELIVERY_P2P=!ON!
    SET MENU_PADDING_D=!MENU_PADDING_UD_ON!
    GOTO :MENU
    )
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" (
    SET UPDATES_DELIVERY_P2P=!OFF!
    SET MENU_PADDING_D=!MENU_PADDING_UD_OFF!
    GOTO :MENU
    )
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" (
    SET UPDATES_DELIVERY_P2P=!IGNORE!
    SET MENU_PADDING_D=!MENU_PADDING_UD_IGNORE!
    GOTO :MENU
    )


:TOGGLE_SD
IF "!DELETE_SOFTWAREDISTRIBUTION!"=="!ON!" (
    SET DELETE_SOFTWAREDISTRIBUTION=!IGNORE!
    SET MENU_PADDING_E=!MENU_PADDING_SD_IGNORE!
    GOTO :MENU
    )
SET DELETE_SOFTWAREDISTRIBUTION=!ON!
SET MENU_PADDING_E=!MENU_PADDING_SD_ON!
GOTO :MENU


:TOGGLE_AO
IF "!ADVANCED_OPTIONS!"=="!ON!" (
    SET ADVANCED_OPTIONS=!OFF!
    SET MENU_0=!MENU_0_OFF!
    GOTO :MENU
    )
SET ADVANCED_OPTIONS=!ON!
SET MENU_0=!MENU_0_ON!
GOTO :MENU


:HUB
CLS
ECHO !SEPARATOR_2!
ECHO  !SCRIPT_NAME! v!VERSION!!POWERSHELL_ID!!PSEXEC_ID!
ECHO !SEPARATOR_2!
ECHO.
ECHO !TAB! 1. !MENU_1! !MENU_PADDING_1! [ !WINDOWS_UPDATE! ]
ECHO !TAB! 2. !MENU_2! !MENU_PADDING_2! [ !SCHEDULED_TASKS! ]
ECHO !TAB! 3. !MENU_3! !MENU_PADDING_3! [ !CHECK_UPDATES! ]
TIMEOUT 2 >NUL

CALL :WINDOWS_UPDATE
CALL :SCHEDULED_TASKS
CALL :CHECK_UPDATES
CALL :END 0


:HUB_AO
CLS
ECHO !SEPARATOR_2!
ECHO  !SCRIPT_NAME! v!VERSION!!POWERSHELL_ID!!PSEXEC_ID!
ECHO !SEPARATOR_2!
ECHO.
ECHO !TAB! A. !MENU_A! !MENU_PADDING_A! [ !NO_AUTOREBOOT! ]
ECHO !TAB! B. !MENU_B! !MENU_PADDING_B! [ !DRIVERS_UPDATE! ]
ECHO !TAB! C. !MENU_C! !MENU_PADDING_C! [ !ETHERNET_CONNECTION_METERED! ]
ECHO !TAB! D. !MENU_D! !MENU_PADDING_D! [ !UPDATES_DELIVERY_P2P! ]
ECHO !TAB! E. !MENU_E! !MENU_PADDING_E! [ !DELETE_SOFTWAREDISTRIBUTION! ]
TIMEOUT 2 >NUL

CALL :NO_AUTOREBOOT
CALL :DRIVERS_UPDATE
CALL :ETHERNET_CONNECTION_METERED
CALL :UPDATES_DELIVERY_P2P
CALL :DELETE_SOFTWAREDISTRIBUTION
CALL :END 0


:WINDOWS_UPDATE
IF "!WINDOWS_UPDATE!"=="!ON!" CALL :WINDOWS_UPDATE_ON
IF "!WINDOWS_UPDATE!"=="!OFF!" CALL :WINDOWS_UPDATE_OFF
EXIT /B


:WINDOWS_UPDATE_ON
ECHO.
ECHO.
ECHO !SEPARATOR_2!
ECHO !TAB! !INFO_WINDOWS_UPDATE_ON_0!
ECHO !SEPARATOR_2!
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_1!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! lanmanworkstation
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query lanmanworkstation >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config lanmanworkstation start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query lanmanworkstation 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start lanmanworkstation
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! eventlog
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query eventlog >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config eventlog start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query eventlog 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start eventlog
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! DHCP
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query dhcp >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config dhcp start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query dhcp 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start dhcp
ECHO !SEPARATOR_1!

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_2!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! TrustedInstaller
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query TrustedInstaller >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config TrustedInstaller start= demand
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query TrustedInstaller 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start TrustedInstaller

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_3!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! MpsSvc
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query MpsSvc >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config MpsSvc start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query MpsSvc 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start MpsSvc
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! BFE
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query BFE >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config BFE start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query BFE 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start BFE

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_4!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! CryptSvc
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query CryptSvc >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config CryptSvc start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query CryptSvc 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start CryptSvc

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_5!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! AppIDSvc
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query AppIDSvc >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config AppIDSvc start= demand
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query AppIDSvc 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start AppIDSvc

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_6!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! W32Time
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query W32Time >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config W32Time start= demand
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query W32Time 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start W32Time
W32tm /config /syncfromflags:manual /manualpeerlist:"0.pool.ntp.org,0x8 1.pool.ntp.org,0x8 2.pool.ntp.org,0x8 3.pool.ntp.org,0x8" /update

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_7!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! NlaSvc
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query NlaSvc >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config NlaSvc start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query NlaSvc 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start NlaSvc
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! netprofm
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query netprofm >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config netprofm start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query netprofm 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start netprofm

ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_8!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! UsoSvc
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query UsoSvc >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config UsoSvc start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query UsoSvc 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start UsoSvc
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! BITS
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query BITS >NUL 2>&1 && %PSEXEC_FULLPATH%!PSEXEC_PARAMS!sc config BITS start= auto
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query BITS 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start BITS
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! wuauserv
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query wuauserv >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config wuauserv start= demand
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query wuauserv 2>&1 | FINDSTR /I stopped >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net start wuauserv

ECHO.
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_9!
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!TAKEOWN /F !USOCLIENT_FILE! /A
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /grant:r !SID_ADMINISTRATORS!:!USOCLIENT_FILE_PERMISSIONS! /C
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /grant:r !SID_AUTH_USERS!:!USOCLIENT_FILE_PERMISSIONS! /C
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /grant:r !SID_USERS!:!USOCLIENT_FILE_PERMISSIONS! /C
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /grant:r !SID_SYSTEM!:!USOCLIENT_FILE_PERMISSIONS! /C
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /setowner !SID_TRUSTED_INSTALLER! /C

ECHO.
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_ON_10!
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG DELETE "!REGKEY!" /f /v NoAutoUpdate >NUL 2>&1
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG DELETE "!REGKEY!" /f /v AUOptions >NUL 2>&1
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Policies\Microsoft\Windows\WindowsUpdate\AU
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG DELETE "!REGKEY!" /f /v NoAutoUpdate >NUL 2>&1
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG DELETE "!REGKEY!" /f /v AUOptions >NUL 2>&1
ECHO !SEPARATOR_1!
EXIT /B


:WINDOWS_UPDATE_OFF
ECHO.
ECHO.
ECHO !SEPARATOR_2!
ECHO !TAB! !INFO_WINDOWS_UPDATE_OFF_0!
ECHO !SEPARATOR_2!
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_OFF_1!
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! BITS
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query BITS >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config BITS start= disabled
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query BITS 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop BITS
ECHO.
ECHO.
ECHO !TAB!+ !SERVICE! wuauserv
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc query wuauserv >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!sc config wuauserv start= disabled
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query wuauserv 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop wuauserv

ECHO.
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_OFF_2!
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!TAKEOWN /F !USOCLIENT_FILE! /A
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!ICACLS !USOCLIENT_FILE! /remove !SID_USERS! !SID_AUTH_USERS! !SID_ADMINISTRATORS! !SID_SYSTEM! /C

ECHO.
ECHO.
ECHO * !INFO_WINDOWS_UPDATE_OFF_3!
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoUpdate /t REG_DWORD /d 1
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v AUOptions /t REG_DWORD /d 2
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Policies\Microsoft\Windows\WindowsUpdate\AU
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoUpdate /t REG_DWORD /d 1
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v AUOptions /t REG_DWORD /d 2
ECHO !SEPARATOR_1!
EXIT /B


:SCHEDULED_TASKS
IF "!SCHEDULED_TASKS!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
IF "!SCHEDULED_TASKS!"=="!ON!" (
    ECHO !TAB! !INFO_SCHEDULED_TASKS_ON_0!
    SET ACTION=enable
    )
IF "!SCHEDULED_TASKS!"=="!OFF!" (
    ECHO !TAB! !INFO_SCHEDULED_TASKS_OFF_0!
    SET ACTION=disable
    )
ECHO !SEPARATOR_2!
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! Scheduled Start
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\WindowsUpdate\Scheduled Start"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! Schedule Scan
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\Schedule Scan"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! USO Broker Display
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\USO_Broker_Display"
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\USO_UXBroker_Display"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! Maintenance Install
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\Maintenance Install"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! Refresh Settings
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\Refresh Settings"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! Reboot
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\UpdateOrchestrator\Reboot"
ECHO.
ECHO.
ECHO !TAB!+ !SCHEDULED_TASK! PerformRemediation
!PSEXEC_FULLPATH!!PSEXEC_PARAMS!schtasks /change /!ACTION! /tn "\Microsoft\Windows\WaaSMedic\PerformRemediation"
ECHO !SEPARATOR_1!
EXIT /B


:CHECK_UPDATES
IF "!CHECK_UPDATES!"=="!OFF!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
ECHO !TAB! !INFO_CHECK_UPDATES_1!
ECHO !SEPARATOR_2!
start ms-settings:windowsupdate-action
EXIT /B


:NO_AUTOREBOOT
IF "!NO_AUTOREBOOT!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
IF "!NO_AUTOREBOOT!"=="!OFF!" ECHO !TAB! !INFO_NO_AUTOREBOOT_0!
IF "!NO_AUTOREBOOT!"=="!ON!" ECHO !TAB! !INFO_NO_AUTOREBOOT_1!
ECHO !SEPARATOR_2!
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU
IF "!NO_AUTOREBOOT!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoRebootWithLoggedOnUsers /t REG_DWORD /d 0
IF "!NO_AUTOREBOOT!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoRebootWithLoggedOnUsers /t REG_DWORD /d 1
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Policies\Microsoft\Windows\WindowsUpdate\AU
IF "!NO_AUTOREBOOT!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoRebootWithLoggedOnUsers /t REG_DWORD /d 0
IF "!NO_AUTOREBOOT!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v NoAutoRebootWithLoggedOnUsers /t REG_DWORD /d 1
ECHO !SEPARATOR_1!
EXIT /B


:DRIVERS_UPDATE
IF "!DRIVERS_UPDATE!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
IF "!DRIVERS_UPDATE!"=="!OFF!" ECHO !TAB! !INFO_DRIVERS_UPDATE_0!
IF "!DRIVERS_UPDATE!"=="!ON!" ECHO !TAB! !INFO_DRIVERS_UPDATE_1!
ECHO !SEPARATOR_2!
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate
IF "!DRIVERS_UPDATE!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG DELETE "!REGKEY!" /f /v ExcludeWUDriversInQualityUpdate
IF "!DRIVERS_UPDATE!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v ExcludeWUDriversInQualityUpdate /t REG_DWORD /d 1
ECHO !SEPARATOR_1!
EXIT /B


:ETHERNET_CONNECTION_METERED
IF "!ETHERNET_CONNECTION_METERED!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
IF "!ETHERNET_CONNECTION_METERED!"=="!OFF!" ECHO !TAB! !INFO_ETHERNET_CONNECTION_METERED_0!
IF "!ETHERNET_CONNECTION_METERED!"=="!ON!" ECHO !TAB! !INFO_ETHERNET_CONNECTION_METERED_1!
ECHO !SEPARATOR_2!
CALL :UNLOCK_REGKEY "SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkList\DefaultMediaCost"
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkList\DefaultMediaCost
IF "!ETHERNET_CONNECTION_METERED!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v Ethernet /t REG_DWORD /d 2
IF "!ETHERNET_CONNECTION_METERED!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v Ethernet /t REG_DWORD /d 1
ECHO !SEPARATOR_1!
EXIT /B


:UPDATES_DELIVERY_P2P
IF "!UPDATES_DELIVERY_P2P!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" ECHO !TAB! !INFO_UPDATES_DELIVERY_P2P_0!
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" ECHO !TAB! !INFO_UPDATES_DELIVERY_P2P_1!
ECHO !SEPARATOR_2!
SET REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization\Config
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v DownloadMode /t REG_DWORD /d 3
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v DownloadMode /t REG_DWORD /d 0
IF "!UPDATES_DELIVERY_P2P!"=="!ON!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v DODownloadMode /t REG_DWORD /d 3
IF "!UPDATES_DELIVERY_P2P!"=="!OFF!" !PSEXEC_FULLPATH!!PSEXEC_PARAMS!REG ADD "!REGKEY!" /f /v DODownloadMode /t REG_DWORD /d 0
ECHO !SEPARATOR_1!
EXIT /B


:DELETE_SOFTWAREDISTRIBUTION
IF "!DELETE_SOFTWAREDISTRIBUTION!"=="!IGNORE!" EXIT /B
ECHO.
ECHO.
ECHO !SEPARATOR_2!
ECHO !TAB! !INFO_DELETE_SOFTWAREDISTRIBUTION!
ECHO !SEPARATOR_2!
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query BITS 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop BITS
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query wuauserv 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop wuauserv
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query AppIDSvc 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop AppIDSvc
%PSEXEC_FULLPATH%%PSEXEC_PARAMS%sc query CryptSvc 2>&1 | FINDSTR /I running >NUL 2>&1 && !PSEXEC_FULLPATH!!PSEXEC_PARAMS!net stop CryptSvc
IF NOT DEFINED PSEXEC_PARAMS (DEL /S /Q !SOFTWAREDISTRIBUTION_FOLDER!) ELSE (!PSEXEC_FULLPATH!!PSEXEC_PARAMS! CMD /C DEL /S /Q !SOFTWAREDISTRIBUTION_FOLDER!)
ECHO !SEPARATOR_1!
EXIT /B


:END
TITLE !SCRIPT_NAME! v!VERSION!
ECHO.
ECHO.
IF DEFINED ALL_PARAMS (
    ECHO  [ !INFO_END_1! ]
    ECHO  [ !INFO_END_3! ]
    TIMEOUT 30 >NUL
) ELSE (
    ECHO  [ !INFO_END_1! ]
    ECHO  [ !INFO_END_2! ]
    PAUSE >NUL
    )
EXIT %1


:WINDOWS_VERSION_CHECK
SET WINDOWS_OK=0
FOR /F "tokens=4-5 delims=. " %%i IN ('VER') DO SET WINDOWS_VERSION=%%i.%%j
IF "!WINDOWS_VERSION!"=="10.0" SET WINDOWS_OK=1
IF !WINDOWS_OK! EQU 0 ECHO !CHECK_WINDOWS_1! & CALL :END 1
EXIT /B


:ADMIN_CHECK
NET SESSION >NUL 2>&1
IF !ERRORLEVEL! NEQ 0 ECHO !CHECK_ADMIN_1! & CALL :END 1
EXIT /B


:PATH_CHECK
FOR /F %%A IN ('CD') DO SET "PATH_COMPARE_1=%%A"
SETLOCAL DISABLEDELAYEDEXPANSION
FOR /F %%A IN ('CD') DO SET "PATH_COMPARE_2=%%A"
SETLOCAL ENABLEDELAYEDEXPANSION
IF !PATH_COMPARE_1! NEQ !PATH_COMPARE_2! ECHO !CHECK_PATH_1! & CALL :END 1
EXIT /B


:POWERSHELL_CHECK
SET POWERSHELL_ID=
SET POWERSHELL_IS=!OFF!

FOR /F "tokens=3" %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\PowerShell\1" /v Install ^| FIND "Install"') DO SET POWERSHELL_INSTALLED=%%A
IF "!POWERSHELL_INSTALLED!"=="0x1" (
    FOR /F "tokens=3" %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\PowerShell\1\PowerShellEngine" /v PowerShellVersion ^| FIND "PowerShellVersion"') DO SET PS_VER_REGVALUE=%%A
    IF [!PS_VER_REGVALUE!]==[] EXIT /B
    SET POWERSHELL_IS=!ON!
    SET POWERSHELL_VERSION=!PS_VER_REGVALUE!
    SET POWERSHELL_ID= // PowerShell v!POWERSHELL_VERSION!
    FOR /F "tokens=3" %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\PowerShell\3\PowerShellEngine" /v PowerShellVersion ^| FIND "PowerShellVersion"') DO SET PS_VER_REGVALUE=%%A
    IF [!PS_VER_REGVALUE!]==[] EXIT /B
    SET POWERSHELL_VERSION=!PS_VER_REGVALUE!
    SET POWERSHELL_ID= // PowerShell v!POWERSHELL_VERSION!
    )
EXIT /B


:CHECKS
CALL :CONSTANTS %*
CALL :LANGUAGE_CHECK %*
CALL :PATH_CHECK %*
CALL :WINDOWS_VERSION_CHECK
CALL :ADMIN_CHECK
CALL :POWERSHELL_CHECK
EXIT /B


:CONSOLE_WINDOW_CHECK
IF "!CONSOLE_WINDOW_CHANGE!"=="!OFF!" EXIT /B
REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE! >NUL 2>&1
IF !ERRORLEVEL! EQU 1 (CALL :CONSOLE_WINDOW_MENU) & (EXIT /B)

SET CONSOLE_GOTO_MENU=0

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE! 2^>NUL ^| FIND "!CONSOLE_SB_REGVALUE!"`) DO (
    SET CONSOLE_REGDATA=%%A
    )
SET CONSOLE_REGDATA_CLEANED=!CONSOLE_REGDATA:0x=!
SET CONSOLE_LINES=!CONSOLE_REGDATA_CLEANED:~0,-4%!
SET CONSOLE_COLUMNS=!CONSOLE_REGDATA_CLEANED:~-4%!
SET /A CONSOLE_LINES=0x!CONSOLE_LINES!
SET /A CONSOLE_COLUMNS=0x!CONSOLE_COLUMNS!
IF !CONSOLE_LINES!!CONSOLE_COLUMNS! EQU !CONSOLE_REGDATA_WINDOW_DEFAULT! (SET CONSOLE_GOTO_MENU=1)
IF !CONSOLE_LINES! LSS !CONSOLE_SB_REGDATA_LINES_OPTIMAL! (SET CONSOLE_GOTO_MENU=1)
IF !CONSOLE_COLUMNS! LSS !CONSOLE_SB_REGDATA_COLUMNS_OPTIMAL! (SET CONSOLE_GOTO_MENU=1)

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_WS_REGVALUE! 2^>NUL ^| FIND "!CONSOLE_WS_REGVALUE!"`) DO (
    SET CONSOLE_REGDATA=%%A
    )
SET CONSOLE_REGDATA_CLEANED=!CONSOLE_REGDATA:0x=!
SET CONSOLE_LINES=!CONSOLE_REGDATA_CLEANED:~0,-4%!
SET CONSOLE_COLUMNS=!CONSOLE_REGDATA_CLEANED:~-4%!
SET /A CONSOLE_LINES=0x!CONSOLE_LINES!
SET /A CONSOLE_COLUMNS=0x!CONSOLE_COLUMNS!
IF !CONSOLE_LINES!!CONSOLE_COLUMNS! EQU !CONSOLE_REGDATA_WINDOW_DEFAULT! (SET CONSOLE_GOTO_MENU=1)
IF !CONSOLE_LINES! LSS !CONSOLE_WS_REGDATA_LINES_OPTIMAL! (SET CONSOLE_GOTO_MENU=1)
IF !CONSOLE_COLUMNS! LSS !CONSOLE_WS_REGDATA_COLUMNS_OPTIMAL! (SET CONSOLE_GOTO_MENU=1)

IF !CONSOLE_GOTO_MENU! EQU 1 (CALL :CONSOLE_WINDOW_MENU)
EXIT /B


:CONSOLE_WINDOW_MENU
IF DEFINED ALL_PARAMS (
    IF "!CONSOLE_WINDOW_CHANGE!"=="!ON!" (
        IF "!CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY!"=="!ON!" GOTO :CONSOLE_WINDOW_SET
        IF "!CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY!"=="!OFF!" EXIT /B
        )
    )

CLS
ECHO !SEPARATOR_2!
ECHO  !SCRIPT_NAME! v!VERSION!
ECHO !SEPARATOR_2!
ECHO.
ECHO  !CONSOLE_MENU_INFO_1!
ECHO  !CONSOLE_MENU_INFO_2!
ECHO.
ECHO  !CONSOLE_MENU_INFO_3!
ECHO !SEPARATOR_2!
ECHO  !CONSOLE_MENU_INFO_4!
ECHO  !CONSOLE_MENU_INFO_5!
ECHO  !CONSOLE_MENU_INFO_6!
ECHO.
SET /P SELECTION=!CONSOLE_MENU_PROMPT! (!CONSOLE_MENU_PROMPT_YES!/!CONSOLE_MENU_PROMPT_NO!): !
SET SELECTION=!SELECTION:~0,1!
IF /I "!SELECTION!"=="!CONSOLE_MENU_PROMPT_YES!" GOTO :CONSOLE_WINDOW_SET
IF /I "!SELECTION!"=="!CONSOLE_MENU_PROMPT_NO!" EXIT /B
ECHO "!SELECTION!" !MENU_ERROR_INFO!
TIMEOUT 2
GOTO :CONSOLE_WINDOW_MENU


:CONSOLE_WINDOW_SET
REG QUERY "!CONSOLE_REGKEY!" /v "!CONSOLE_SB_REGVALUE_BACKUP!" >NUL 2>&1
IF !ERRORLEVEL! EQU 0 (CALL :CONSOLE_WINDOW_SET_RESTORE) & (EXIT /B)
IF !ERRORLEVEL! EQU 1 (CALL :CONSOLE_WINDOW_SET_CHANGE) & (EXIT /B)


:CONSOLE_WINDOW_SET_RESTORE
REG QUERY "!CONSOLE_REGKEY!" /v "!CONSOLE_SB_REGVALUE_BACKUP!" >NUL 2>&1
IF !ERRORLEVEL! EQU 1 EXIT /B

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE_BACKUP! 2^>NUL ^| FIND "!CONSOLE_SB_REGVALUE_BACKUP!"`) DO (
    SET CONSOLE_REGDATA_BACKUP=%%A
    )
SET /A CONSOLE_REGDATA_BACKUP=!CONSOLE_REGDATA_BACKUP!
IF "!CONSOLE_WINDOW_RESTORE!"=="!ON!" REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_SB_REGVALUE! /t REG_DWORD /d %CONSOLE_REGDATA_BACKUP% >NUL 2>&1
REG DELETE "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE_BACKUP! /f >NUL 2>&1

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_WS_REGVALUE_BACKUP! 2^>NUL ^| FIND "!CONSOLE_WS_REGVALUE_BACKUP!"`) DO (
    SET CONSOLE_REGDATA_BACKUP=%%A
    )
SET /A CONSOLE_REGDATA_BACKUP=!CONSOLE_REGDATA_BACKUP!
IF "!CONSOLE_WINDOW_RESTORE!"=="!ON!" REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_WS_REGVALUE! /t REG_DWORD /d %CONSOLE_REGDATA_BACKUP% >NUL 2>&1
REG DELETE "!CONSOLE_REGKEY!" /v !CONSOLE_WS_REGVALUE_BACKUP! /f >NUL 2>&1
EXIT /B


:CONSOLE_WINDOW_SET_CHANGE
REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE_BACKUP! >NUL 2>&1
IF !ERRORLEVEL! EQU 0 EXIT /B

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_SB_REGVALUE! 2^>NUL ^| FIND "!CONSOLE_SB_REGVALUE!"`) DO (
    SET CONSOLE_REGDATA=%%A
    )
SET /A CONSOLE_REGDATA=!CONSOLE_REGDATA!
REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_SB_REGVALUE_BACKUP! /t REG_DWORD /d %CONSOLE_REGDATA% >NUL 2>&1
CMD /C EXIT !CONSOLE_SB_REGDATA_LINES_OPTIMAL!
SET "CONSOLE_LINES=!=ExitCode!"
CMD /C EXIT !CONSOLE_SB_REGDATA_COLUMNS_OPTIMAL!
SET "CONSOLE_COLUMNS=!=ExitCode!"
SET CONSOLE_LINES=!CONSOLE_LINES:~-4%!
SET CONSOLE_COLUMNS=!CONSOLE_COLUMNS:~-4%!
SET /A CONSOLE_REGDATA=0x!CONSOLE_LINES!!CONSOLE_COLUMNS!
REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_SB_REGVALUE! /t REG_DWORD /d !CONSOLE_REGDATA! >NUL 2>&1

FOR /F "usebackq tokens=3" %%A IN (`REG QUERY "!CONSOLE_REGKEY!" /v !CONSOLE_WS_REGVALUE! 2^>NUL ^| FIND "!CONSOLE_WS_REGVALUE!"`) DO (
    SET CONSOLE_REGDATA=%%A
    )
SET /A CONSOLE_REGDATA=!CONSOLE_REGDATA!
REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_WS_REGVALUE_BACKUP! /t REG_DWORD /d %CONSOLE_REGDATA% >NUL 2>&1
CMD /C EXIT !CONSOLE_WS_REGDATA_LINES_OPTIMAL!
SET "CONSOLE_LINES=!=ExitCode!"
CMD /C EXIT !CONSOLE_WS_REGDATA_COLUMNS_OPTIMAL!
SET "CONSOLE_COLUMNS=!=ExitCode!"
SET CONSOLE_LINES=!CONSOLE_LINES:~-4%!
SET CONSOLE_COLUMNS=!CONSOLE_COLUMNS:~-4%!
SET /A CONSOLE_REGDATA=0x!CONSOLE_LINES!!CONSOLE_COLUMNS!
REG ADD "!CONSOLE_REGKEY!" /f /v !CONSOLE_WS_REGVALUE! /t REG_DWORD /d !CONSOLE_REGDATA! >NUL 2>&1

SETLOCAL DISABLEDELAYEDEXPANSION
%CURRENTDRIVE%
CD %CURRENTPATH%
START CMD /C "%CURRENTFILE%" %ALL_PARAMS% & EXIT 0


:UNLOCK_REGKEY
IF [%1]==[] EXIT /B
IF !POWERSHELL_IS!==!OFF! EXIT /B

SET PS_TMP_NAME=WUT-!RANDOM!!RANDOM!.PS1
SET PS_TMP_FULLPATH="!TMP!\!PS_TMP_NAME!"
SET CMD_TMP_NAME=WUT-!RANDOM!!RANDOM!.CMD
SET CMD_TMP_FULLPATH="!TMP!\!CMD_TMP_NAME!"

CALL :CREATE_PS_REG_PERMISSIONS_FILE !PS_TMP_FULLPATH! %1
IF NOT EXIST !PS_TMP_FULLPATH! EXIT /B
CALL :CREATE_CMD_RUN_PS_REG_FILE !CMD_TMP_FULLPATH! !PS_TMP_FULLPATH!
IF NOT EXIST !CMD_TMP_FULLPATH! EXIT /B
CALL !CMD_TMP_FULLPATH!
TIMEOUT 3 > NUL
DEL !PS_TMP_FULLPATH!
DEL !CMD_TMP_FULLPATH!
EXIT /B


:CREATE_PS_REG_PERMISSIONS_FILE
ECHO # !DELETE_TEMP_FILE_NOTICE_1! > %1
ECHO # !DELETE_TEMP_FILE_NOTICE_2! >> %1
ECHO $definition = @^" >> %1
ECHO using System; >> %1
ECHO using System.Runtime.InteropServices; >> %1
ECHO namespace Win32Api >> %1
ECHO { >> %1
ECHO public class NtDll >> %1
ECHO { >> %1
ECHO [DllImport(^"ntdll.dll^", EntryPoint=^"RtlAdjustPrivilege^")] >> %1
ECHO public static extern int RtlAdjustPrivilege(ulong Privilege, bool Enable, bool CurrentThread, ref bool Enabled); >> %1
ECHO } >> %1
ECHO } >> %1
ECHO ^"@ >> %1
ECHO Add-Type -TypeDefinition $definition -PassThru >> %1
ECHO $bEnabled = $false >> %1
ECHO $res = [Win32Api.NtDll]::RtlAdjustPrivilege(9, $true, $false, [ref]$bEnabled) >> %1
ECHO $key = [Microsoft.Win32.Registry]::LocalMachine.OpenSubKey(%2, [Microsoft.Win32.RegistryKeyPermissionCheck]::ReadWriteSubTree,[System.Security.AccessControl.RegistryRights]::takeownership) >> %1
ECHO $acl = $key.GetAccessControl() >> %1
ECHO $account = New-Object -TypeName System.Security.Principal.SecurityIdentifier(^"S-1-5-32-544^") >> %1
ECHO $acl.SetOwner($account) >> %1
ECHO $key.SetAccessControl($acl) >> %1
ECHO $rule = New-Object System.Security.AccessControl.RegistryAccessRule ($account,^"FullControl^",^"Allow^") >> %1
ECHO $acl.SetAccessRule($rule) >> %1
ECHO $key.SetAccessControl($acl) >> %1
EXIT /B


:CREATE_CMD_RUN_PS_REG_FILE
ECHO @ECHO OFF > %1
ECHO :: !DELETE_TEMP_FILE_NOTICE_1! >> %1
ECHO :: !DELETE_TEMP_FILE_NOTICE_2! >> %1
ECHO !PSEXEC_FULLPATH!!PSEXEC_EULA!PowerShell.exe -Command ^"^& {Start-Process PowerShell.exe -ArgumentList '-ExecutionPolicy Bypass -File ^"%2^"' -Verb RunAs}^" >> %1
EXIT /B


:APPLY_USER_SETTINGS
CALL :EARLY_CHECK_COMMAND_LINE %*
CALL :CONSOLE_WINDOW_CHECK
CALL :CONSOLE_WINDOW_SET_RESTORE
CALL :CHECK_PSEXEC
EXIT /B


:CHECK_PSEXEC
IF "!USE_PSEXEC!"=="!ON!" (
    IF EXIST "!CURRENTPATH!PsExec.exe" SET PSEXEC=PsExec.exe
    IF EXIST "!CURRENTPATH!PsExec64.exe" (
        IF !OS_BITS!==32 (
            SET PSEXEC_ID= // !INFO_PSEXEC_ERROR!
        ) ELSE (
            SET PSEXEC=PsExec64.exe
            )
        )
    IF DEFINED PSEXEC (
        IF "!PSEXEC_EULA!"=="!ON!" SET PSEXEC_EULA=-accepteula !
        IF "!PSEXEC_EULA!"=="!OFF!" SET PSEXEC_EULA= !
        SET PSEXEC_FULLPATH="!CURRENTPATH!!PSEXEC!" !
        SET PSEXEC_PARAMS=!PSEXEC_EULA!!PSEXEC_PARAMS! !
        SET PSEXEC_ID= // !PSEXEC! !INFO_PSEXEC!
    ) ELSE (
        SET PSEXEC_PARAMS=
        )
    )
EXIT /B


:EARLY_CHECK_COMMAND_LINE
IF "%~1"=="" EXIT /B

FOR %%P IN (!ALL_PARAMS!) DO (
    IF /I "%%P"=="-ENG" (CALL :LANG_ENG) & (CALL :LANG_ENG_CMDLINE)
    IF /I "%%P"=="-ING" (CALL :LANG_ENG) & (CALL :LANG_ENG_CMDLINE)
    IF /I "%%P"=="-ESP" (CALL :LANG_ESP) & (CALL :LANG_ESP_CMDLINE)
    IF /I "%%P"=="-SPA" (CALL :LANG_ESP) & (CALL :LANG_ESP_CMDLINE)
    IF /I "%%P"=="-!CMDLINE_CWAA!!ON!" (SET CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY=!ON!)
    IF /I "%%P"=="-!CMDLINE_CWAA!!OFF!" (SET CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY=!OFF!)
    IF /I "%%P"=="-!CMDLINE_CWAA!!IGNORE!" (SET CONSOLE_WINDOW_COMMAND_LINE_AUTOAPPLY=!IGNORE!)
    )
EXIT /B


:LANGUAGE_CHECK
IF /I "!IGNORE_SYSTEM_LANGUAGE!"=="Y" (
    CALL :LANG_!FORCE_LANGUAGE!
    CALL :LANG_!FORCE_LANGUAGE!_CMDLINE
    EXIT /B
    )

ver /?|FIND /I "muestra" >NUL 2>&1
IF !ERRORLEVEL! EQU 0 (SET LANGUAGE=ESP) ELSE (SET LANGUAGE=ENG)
CALL :LANG_!LANGUAGE!
CALL :LANG_!LANGUAGE!_CMDLINE
EXIT /B


:LANG_ENG
SET ON=ON
SET OFF=OFF
SET IGNORE=IGNORE
SET SERVICE=Service:
SET SCHEDULED_TASK=Scheduled Task:
SET CHECK_WINDOWS_1=!SCRIPT_NAME! v!VERSION! requires Windows 10.
SET CHECK_ADMIN_1=!SCRIPT_NAME! v!VERSION! requires administrative privileges to work properly.
SET CHECK_PATH_1=!SCRIPT_NAME! v!VERSION! requires to be in a folder without the exclamation mark character in its path.!NEWLINE!Sorry for the inconvenience.
SET CONSOLE_MENU_INFO_1=In order to use and view this script optimally you will need a proper size for the console window.
SET CONSOLE_MENU_INFO_2=That is, a minimum number of columns and screen buffers for the window you are seeing.
SET CONSOLE_MENU_INFO_3=This setting will modify four values in the Windows Registry for the current user.
SET CONSOLE_MENU_INFO_4=Notes:
SET CONSOLE_MENU_INFO_5=+ Either way, this won't affect the script functionality.
SET CONSOLE_MENU_INFO_6=+ The changes will be undone automatically.
SET CONSOLE_MENU_PROMPT=Do you want to set the appropiate values?
SET CONSOLE_MENU_PROMPT_YES=Y
SET CONSOLE_MENU_PROMPT_NO=N
SET MENU_TITLE_1=COMMON OPTIONS
SET MENU_TITLE_2=ADVANCED OPTIONS
SET MENU_1=Windows Updates:
SET MENU_2=Related scheduled tasks:
SET MENU_3=Check updates now:
SET MENU_A=Allow an automatic reboot after updates:
SET MENU_B=Device drivers update through Windows Update:
SET MENU_C=Set wired connection (ethernet) as metered:
SET MENU_D=The delivery of Windows Updates includes P2P:
SET MENU_E=Delete the SoftwareDistribution folder:
SET MENU_APPLY_CO=Apply changes^!
SET MENU_APPLY_AO=Apply Advanced Options^!
SET MENU_EXIT=Exit
SET MENU_0_ON=Hide Advanced Options
SET MENU_0_OFF=Show Advanced Options
SET MENU_INFO_1=You can toggle an option (1-3), apply the indicated settings (4) or exit (5).
SET MENU_INFO_2=Also, you can toggle the Advanced Options (A-E) or apply the changes (9).
SET MENU_INFO_3=NOTE: Options marked with [*] denote a Windows default setting.
SET MENU_PROMPT=Select a value: !
SET MENU_ERROR_INFO=is not a valid selection.
SET MENU_AO_INFO_1=Don't touch them if you don't know exactly what they do.
SET MENU_AO_INFO_2=The OS will need to identify the changes after you apply any one.
SET MENU_AO_INFO_3=For this to happen you have to log-off or reboot the computer.
SET MENU_AO_INFO_4=Following that, the changes will be activated.
SET MENU_AO_INFO_5=Otherwise they won't get applied in the Common Options if you need them to.
SET MENU_AO_INFO_6=REMEMBER: 1) apply, 2) identify, 3) Common Options.
SET MENU_PADDING_WU_ON=                                                   !
SET MENU_PADDING_WU_OFF=                                                  !
SET MENU_PADDING_WU_IGNORE=                                               !
SET MENU_PADDING_ST_ON=                                           !
SET MENU_PADDING_ST_OFF=                                          !
SET MENU_PADDING_ST_IGNORE=                                       !
SET MENU_PADDING_CU_ON=                                                 !
SET MENU_PADDING_CU_OFF=                                                !
SET MENU_PADDING_NA_ON=                           !
SET MENU_PADDING_NA_OFF=                          !
SET MENU_PADDING_NA_IGNORE=                       !
SET MENU_PADDING_DU_ON=                      !
SET MENU_PADDING_DU_OFF=                     !
SET MENU_PADDING_DU_IGNORE=                  !
SET MENU_PADDING_MC_ON=                        !
SET MENU_PADDING_MC_OFF=                       !
SET MENU_PADDING_MC_IGNORE=                    !
SET MENU_PADDING_UD_ON=                      !
SET MENU_PADDING_UD_OFF=                     !
SET MENU_PADDING_UD_IGNORE=                  !
SET MENU_PADDING_SD_ON=                            !
SET MENU_PADDING_SD_IGNORE=                        !
SET INFO_PSEXEC=detected
SET INFO_PSEXEC_ERROR=Error: Incompatible PsExec version (32-bit Windows)
SET INFO_WINDOWS_UPDATE_ON_0=Enabling Windows Update...
SET INFO_WINDOWS_UPDATE_ON_1=Windows Update required services
SET INFO_WINDOWS_UPDATE_ON_2=Windows Modules Installer service
SET INFO_WINDOWS_UPDATE_ON_3=Windows Firewall related services
SET INFO_WINDOWS_UPDATE_ON_4=Cryptographic service
SET INFO_WINDOWS_UPDATE_ON_5=Application Identity
SET INFO_WINDOWS_UPDATE_ON_6=Windows Time service
SET INFO_WINDOWS_UPDATE_ON_7=Network required services
SET INFO_WINDOWS_UPDATE_ON_8=Windows Update services
SET INFO_WINDOWS_UPDATE_ON_9=Unlocking the UsoClient (Client for the Update Schedule Orchestrator) file...
SET INFO_WINDOWS_UPDATE_ON_10=Enabling automatic updates...
SET INFO_WINDOWS_UPDATE_OFF_0=Disabling Windows Update...
SET INFO_WINDOWS_UPDATE_OFF_1=Windows Update services
SET INFO_WINDOWS_UPDATE_OFF_2=Locking up the UsoClient (Client for the Update Schedule Orchestrator) file...
SET INFO_WINDOWS_UPDATE_OFF_3=Disabling automatic updates...
SET INFO_SCHEDULED_TASKS_ON_0=Enabling/restoring Windows Update related tasks for the Task Scheduler...
SET INFO_SCHEDULER_TASKS_OFF_0=Disabling Windows Update related tasks for the Task Scheduler...
SET INFO_CHECK_UPDATES_1=Checking for updates...
SET INFO_NO_AUTOREBOOT_0=Disabling the automatic reboot of Windows so updates get installed or applied...
SET INFO_NO_AUTOREBOOT_1=Enabling the automatic reboot of Windows so updates get installed or applied...
SET INFO_DRIVERS_UPDATE_0=Disabling the update of device drivers through Windows Update...
SET INFO_DRIVERS_UPDATE_1=Enabling the update of device drivers through Windows Update...
SET INFO_ETHERNET_CONNECTION_METERED_0=Setting the cabled connection (ethernet) as metered...
SET INFO_ETHERNET_CONNECTION_METERED_1=Setting the cabled connection (ethernet) as non-metered...
SET INFO_UPDATES_DELIVERY_P2P_0=Disabling the local and Internet peer-to-peer network modes for the Windows Update delivery...
SET INFO_UPDATES_DELIVERY_P2P_1=Enabling the local and Internet peer-to-peer network modes for the Windows Update delivery...
SET INFO_DELETE_SOFTWAREDISTRIBUTION=Deleting the SoftwareDistribution folder...
SET INFO_END_1=Finished
SET INFO_END_2=Press any key to exit
SET INFO_END_3=!SCRIPT_NAME! will be closed in 30 seconds
SET DELETE_TEMP_FILE_NOTICE_1=Script created by !SCRIPT_NAME! v!VERSION!
SET DELETE_TEMP_FILE_NOTICE_2=(You can safely delete this file.)
EXIT /B


:LANG_ENG_CMDLINE
SET CMDLINE_WU=WindowsUpdate
SET CMDLINE_ST=ScheduledTasks
SET CMDLINE_CU=CheckUpdates
SET CMDLINE_NA=NoAutoReboot
SET CMDLINE_DU=DriversWindowsUpdate
SET CMDLINE_MC=EthernetConnectionMetered
SET CMDLINE_UD=UpdatesDeliveryP2P
SET CMDLINE_SD=DeleteSoftwareDistributionFolder
SET CMDLINE_CWAA=ConsoleWindowAutoApply
EXIT /B


:LANG_ESP
SET ON=ACTIVADO
SET OFF=DESACTIVADO
SET IGNORE=IGNORAR
SET SERVICE=Servicio:
SET SCHEDULED_TASK=Tarea programada:
SET CHECK_WINDOWS_1=!SCRIPT_NAME! v!VERSION! requiere Windows 10.
SET CHECK_ADMIN_1=!SCRIPT_NAME! v!VERSION! requiere permisos administrativos para funcionar correctamente.
SET CHECK_PATH_1=!SCRIPT_NAME! v!VERSION! requiere encontrarse en una carpeta sin el caracter de admiración en su ruta.!NEWLINE!Perdón por las molestias.
SET CONSOLE_MENU_INFO_1=Para poder usar y ver este script de manera óptima necesitará que la ventana de consola tenga
SET CONSOLE_MENU_INFO_2=unas dimensiones apropiadas; es decir, un número mínimo de columnas y reservas de pantalla.
SET CONSOLE_MENU_INFO_3=Este ajuste modificará cuatro valores en el Registro de Windows para el usuario actual.
SET CONSOLE_MENU_INFO_4=Notas:
SET CONSOLE_MENU_INFO_5=+ Se aplique o no, este cambio no afectará a la funcionalidad del script.
SET CONSOLE_MENU_INFO_6=+ Los cambios se desharán automáticamente.
SET CONSOLE_MENU_PROMPT=¿Desea ajustar los valores apropiados?
SET CONSOLE_MENU_PROMPT_YES=S
SET CONSOLE_MENU_PROMPT_NO=N
SET MENU_TITLE_1=OPCIONES COMUNES
SET MENU_TITLE_2=OPCIONES AVANZADAS
SET MENU_1=Actualizaciones de Windows:
SET MENU_2=Tareas programadas relacionadas:
SET MENU_3=Comprobar actualizaciones ahora:
SET MENU_A=Permitir el reinicio automático tras actualizaciones:
SET MENU_B=Instalar controladores mediante Windows Update:
SET MENU_C=Conexión cableada (ethernet) de uso medido:
SET MENU_D=Distribución de actualizaciones de Windows incluyendo P2P:
SET MENU_E=Borrar la carpeta SoftwareDistribution:
SET MENU_APPLY_CO=Aplicar cambios^!
SET MENU_APPLY_AO=Aplicar Opciones Avanzadas^!
SET MENU_EXIT=Salir
SET MENU_0_ON=Oculta las Opciones Avanzadas
SET MENU_0_OFF=Muestra las Opciones Avanzadas
SET MENU_INFO_1=Puede conmutar una opción (1-3), aplicar las opciones indicadas (4) o salir (5).
SET MENU_INFO_2=Además, puede conmutar las Opciones Avanzadas (A-E) o aplicar los cambios (9).
SET MENU_INFO_3=NOTA: Las opciones marcadas con [*] denotan un valor predeterminado de Windows.
SET MENU_PROMPT=Elija un valor: !
SET MENU_ERROR_INFO=no es una elección válida.
SET MENU_AO_INFO_1=No las cambie si no sabe exactamente lo que hacen.
SET MENU_AO_INFO_2=El sistema necesitará identificar los cambios realizados.
SET MENU_AO_INFO_3=Tras aplicar, tiene que cerrar sesión o reiniciar el sistema.
SET MENU_AO_INFO_4=Después de esto, los cambios estarán activados.
SET MENU_AO_INFO_5=De otro modo no se aplicarán en las Opciones Comunes si lo necesita.
SET MENU_AO_INFO_6=RECUERDE: 1) aplique, 2) identifique, 3) Opciones Comunes.
SET MENU_PADDING_WU_ON=                                  !
SET MENU_PADDING_WU_OFF=                               !
SET MENU_PADDING_WU_IGNORE=                                   !
SET MENU_PADDING_ST_ON=                             !
SET MENU_PADDING_ST_OFF=                          !
SET MENU_PADDING_ST_IGNORE=                              !
SET MENU_PADDING_CU_ON=                             !
SET MENU_PADDING_CU_OFF=                          !
SET MENU_PADDING_NA_ON=        !
SET MENU_PADDING_NA_OFF=     !
SET MENU_PADDING_NA_IGNORE=         !
SET MENU_PADDING_DU_ON=              !
SET MENU_PADDING_DU_OFF=           !
SET MENU_PADDING_DU_IGNORE=               !
SET MENU_PADDING_MC_ON=                  !
SET MENU_PADDING_MC_OFF=               !
SET MENU_PADDING_MC_IGNORE=                   !
SET MENU_PADDING_UD_ON=   !
SET MENU_PADDING_UD_OFF=!
SET MENU_PADDING_UD_IGNORE=    !
SET MENU_PADDING_SD_ON=                      !
SET MENU_PADDING_SD_IGNORE=                       !
SET INFO_PSEXEC=detectado
SET INFO_PSEXEC_ERROR=Error: Versión de PsExec incompatible (Windows de 32-bits)
SET INFO_WINDOWS_UPDATE_ON_0=Habilitando Windows Update...
SET INFO_WINDOWS_UPDATE_ON_1=Servicios relacionados con Windows Update
SET INFO_WINDOWS_UPDATE_ON_2=Servicio Instalador de Módulos de Windows
SET INFO_WINDOWS_UPDATE_ON_3=Servicios relacionados con el Cortafuegos de Windows
SET INFO_WINDOWS_UPDATE_ON_4=Servicio de criptografía
SET INFO_WINDOWS_UPDATE_ON_5=Servicio de Identidad de aplicación
SET INFO_WINDOWS_UPDATE_ON_6=Servicio de Hora de Windows
SET INFO_WINDOWS_UPDATE_ON_7=Servicios de red necesarios
SET INFO_WINDOWS_UPDATE_ON_8=Servicios de Windows Update
SET INFO_WINDOWS_UPDATE_ON_9=Desbloqueando UsoClient (Cliente para el organizador encargado de programar actualizaciones)...
SET INFO_WINDOWS_UPDATE_ON_10=Habilitando actualizaciones automáticas...
SET INFO_WINDOWS_UPDATE_OFF_0=Deshabilitando Windows Update...
SET INFO_WINDOWS_UPDATE_OFF_1=Servicios de Windows Update
SET INFO_WINDOWS_UPDATE_OFF_2=Bloqueando UsoClient (Cliente para el organizador encargado de programar actualizaciones)...
SET INFO_WINDOWS_UPDATE_OFF_3=Deshabilitando actualizaciones automáticas...
SET INFO_SCHEDULED_TASKS_ON_0=Habilitando/restaurando las relacionadas con Windows Update en el Programador de Tareas...
SET INFO_SCHEDULED_TASKS_OFF_0=Deshabilitando las tareas relacionadas con Windows Update en el Programador de Tareas...
SET INFO_CHECK_UPDATES_1=Comprobando si hay actualizaciones...
SET INFO_NO_AUTOREBOOT_0=Deshabilitando el reinicio automático de Windows tras las actualizaciones...
SET INFO_NO_AUTOREBOOT_1=Habilitando el reinicio automático de Windows tras las actualizaciones...
SET INFO_DRIVERS_UPDATE_0=Deshabilitando la instalación de controladores mediante Windows Update...
SET INFO_DRIVERS_UPDATE_1=Habilitando la instalación de controladores mediante Windows Update...
SET INFO_ETHERNET_CONNECTION_METERED_0=Configurando la conexión cableada (ethernet) para que no sea del tipo medido...
SET INFO_ETHERNET_CONNECTION_METERED_1=Configurando la conexión cableada (ethernet) para que sea del tipo medido...
SET INFO_UPDATES_DELIVERY_P2P_0=Deshabilitando el añadido de los modos de red P2P para las actualizaciones...
SET INFO_UPDATES_DELIVERY_P2P_1=Habilitando el añadido de los modos de red P2P para las actualizaciones...
SET INFO_DELETE_SOFTWAREDISTRIBUTION=Borrando la carpeta SoftwareDistribution...
SET INFO_END_1=Terminado
SET INFO_END_2=Pulse una tecla para salir
SET INFO_END_3=!SCRIPT_NAME! se cerrará en 30 segundos
SET DELETE_TEMP_FILE_NOTICE_1=Script creado por !SCRIPT_NAME! v!VERSION!
SET DELETE_TEMP_FILE_NOTICE_2=(Puede borrar este fichero sin problemas.)
EXIT /B


:LANG_ESP_CMDLINE
SET CMDLINE_WU=WindowsUpdate
SET CMDLINE_ST=TareasProgramadas
SET CMDLINE_CU=CompruebaActualizaciones
SET CMDLINE_NA=NoAutoReinicio
SET CMDLINE_DU=ControladoresWindowsUpdate
SET CMDLINE_MC=EthernetDeUsoMedido
SET CMDLINE_UD=EntregaDeActualizacionesP2P
SET CMDLINE_SD=BorraCarpetaSoftwareDistribution
SET CMDLINE_CWAA=AutoAplicaVentanaDeConsola
EXIT /B


:CONSTANTS
SET SCRIPT_NAME=WinUpdateToggler
SET VERSION=0.8
SET CONSOLE_REGKEY=HKEY_CURRENT_USER\Console
SET CONSOLE_SB_REGVALUE=ScreenBufferSize
SET CONSOLE_SB_REGVALUE_BACKUP=ScreenBufferSizeBackup
SET CONSOLE_WS_REGVALUE=WindowSize
SET CONSOLE_WS_REGVALUE_BACKUP=WindowSizeBackup
SET CONSOLE_REGDATA_WINDOW_DEFAULT=190050
SET CONSOLE_SB_REGDATA_LINES_OPTIMAL=1000
SET CONSOLE_SB_REGDATA_COLUMNS_OPTIMAL=100
SET CONSOLE_WS_REGDATA_LINES_OPTIMAL=35
SET CONSOLE_WS_REGDATA_COLUMNS_OPTIMAL=100
SET SEPARATOR_1=----------------------------------------------------------------------------------------------------
SET SEPARATOR_2=====================================================================================================
SET SEPARATOR_3=------------------------------------------------------------------------------
SET TAB=	!
(SET NEWLINE=^
%=OOLYAKOO=%
)
SET OS_BITS=64
IF "%PROCESSOR_ARCHITECTURE%"=="x86" (
    IF NOT DEFINED PROCESSOR_ARCHITEW6432 SET OS_BITS=32
    )
SET SYSTEM_PATH=%SystemRoot%\System32
SET USOCLIENT_FILE="!SYSTEM_PATH!\UsoClient.exe"
SET USOCLIENT_FILE_PERMISSIONS=(RX,R)
SET SOFTWAREDISTRIBUTION_FOLDER="%WINDIR%\SoftwareDistribution"
SET SID_ADMINISTRATORS=*S-1-5-32-544
SET SID_AUTH_USERS=*S-1-5-11
SET SID_USERS=*S-1-5-32-545
SET SID_SYSTEM=*S-1-5-18
SET SID_TRUSTED_INSTALLER=*S-1-5-80-956008885-3418522649-1831038044-1853292631-2271478464
SET ALL_PARAMS=%*
SET CURRENTDRIVE=%~d0
SET "CURRENTPATH=%~dp0"
SET CURRENTFILE=%~nx0
SET PSEXEC_PARAMS=-s
CHCP 65001 >NUL
COLOR 8F
EXIT /B